#!/usr/bin/env python
from bbio import *
#from SafeProcess import *
import smbus

DISPLAYADDR = 0x29

i2c = smbus.SMBus(3)

lastDotx = 0
lastDoty = -1
lastDotTime = 0

def setup():
	print "startup, waiting for arduino to boot"
	while not i2c_send("CLR~BLA"): #clear black
		delay(200)
	delay(1000) #CLR needs a little extra time
	i2c_send("TEXT~Status~-1~0~PUR~AQU")
	print "done"

def loop():
	global lastDotx, lastDoty,lastDotTime
	connected = True
#	print "get vals"
	if i2c_send("TEMP"):
		temp = i2c_read()
	else:
		connected = False
	
	if connected:
		i2c_send("HUMID")
		humid = i2c_read()
		
	#	print "send: TEXT~{0}~-1~20~GRE~BLA".format(time.strftime('%x %X'))
		i2c_send("TEXT~{0}~-1~20~GRE~BLA".format(time.strftime('%x %X')))
	#	print "send: TEXT~{0}F {1}%~-1~40~GRE~BLA".format(temp, humid)
		i2c_send("TEXT~{0}F {1}%~-1~40~GRE~BLA".format(temp, humid))
		
		if (lastDotTime + 300) < time.time():
			tempi = ((int(float(temp)*10) - 550) * 2) / 10 #floor at 55F
			if tempi < 0:
				tempi = 0
			if lastDoty > 0: #make it the normal color
				i2c_send("DOT~{0}~{1}~GRE".format(lastDotx-1, lastDoty))
			lastDoty = 239 - tempi
			if lastDotx > 319:
				lastDotx = 0;
			i2c_send("LINE~{0}~{1}~{2}~{3}~BLA".format(lastDotx, 100, lastDotx, 239)) #wipe the new line
			i2c_send("DOT~{0}~{1}~RED".format(lastDotx, lastDoty))
			lastDotx += 1
			lastDotTime = time.time()
			delay(500) #there are many delay's above, this evens it to about 1 second
		else:
			delay(600) #there are many delay's above, this evens it to about 1 second
	else: #wait for reconnect
		print "connection lost, waiting for arduino to boot"
		while not i2c_send("CLR~BLA"): #clear black
			delay(2000)
		delay(1000) #CLR needs a little extra time
		i2c_send("TEXT~Status~-1~0~PUR~AQU")
		lastDotTime = 0 #reset the graph
		print "done"
		
def i2c_send(data):
	try:
		for c in data:
			x = i2c.write_byte(DISPLAYADDR, ord(c))
		
		x = i2c.write_byte(DISPLAYADDR, 0)
		delay(100) #give time for processing
		return True
	except:
		print "i2c send error", sys.exc_info()[0]
		return False
		
def i2c_read():
	data = ""
	try:
		buf = i2c.read_byte(DISPLAYADDR)
		while buf > 0:
			data += chr(buf);
			buf = i2c.read_byte(DISPLAYADDR)
	except:
		print "i2c send error", sys.exc_info()[0]
	return data
	
run(setup, loop)

